<?php
/**
 * @package		Zaragoza Seo Complements 1.0
 * @copyright	(C) 2009 Zaragozaonline.com. All rights reserved.
 * @license		GNU/GPL 2.0
 * @author		Ciro Artigot <info@zaragozaonline.com>
 */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemZaragoza_Seo extends JPlugin
{

	function plgSystemZaragoza_Seo(& $subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onAfterDispatch()
	{
		global $mainframe;
		
		//si estamos en el backend no hacemos nada
		if($mainframe->isAdmin()) {return;}
		
		$document =& JFactory::getDocument();
		$db = & JFactory::getDBO();

		$nombredelsitio = '';
		
		if($this->params->get('nombredelsitio'))
			{	$nombredelsitio = $this->params->get('nombredelsitio');	}
		else
			{	$nombredelsitio = $mainframe->getCfg('sitename');	}
		
		$menu =& JSite::getMenu();
		$titulo = $document->getTitle();
		
		// si queremos que el plugin maneje el titulo
		if($this->params->get('seotitle')){
			if ($menu->getActive()==$menu->getDefault()) {
				$document->setTitle($nombredelsitio);
				}
			else
				{	$separador = ' '.trim($this->params->get('separador')).' ';
					$pagina ='';
					$prefix = '';
					
					if(isset($_REQUEST['limitstart'])&&isset($_REQUEST['limit'])) { 
					
						$limitstart = JRequest::getInt('limitstart');
						$limit = JRequest::getInt('limit');
						$pagina = ($limitstart / $limit ) + 1;
						
						$titulo .= $separador.$this->params->get('prefix').' '.$pagina;
						
						if(!$this->params->get('posicion')) {$titulo .= $separador;}
					}
	
					if($this->params->get('posicion')) {				
							$titulo = $titulo.$separador.$nombredelsitio;}
					else
						{	$titulo = $nombredelsitio.$separador.$titulo;}
				}
			$document->setTitle($titulo);
		}
		
			// si queremos que el plugin maneje el meta description
		if($this->params->get('seodescription')){
			
			$description = $this->params->get('descripcion');
				
			if ($menu->getActive()==$menu->getDefault()) {// tendremos que poner el meta description nuestro en frontpage
				}
			else
				{	$pasamos = 0;
					//si es un articulo
					if(isset($_REQUEST['view'])&&isset($_REQUEST['id'])){
					
						if($_REQUEST['view']=='article'&&$_REQUEST['id'])
						{
							$query = "SELECT `introtext`,`fulltext`,`metadesc` FROM #__content WHERE id=".(int)$_REQUEST['id'];
							
							//echo($query);
							$db->setQuery($query);
							$row = $db->loadObject();
							if($row->metadesc) { $description = $row->metadesc;}	
							else {
								if($row->introtext) { $description = plgSystemZaragoza_Seo::cut_string(strip_tags($row->introtext),350);}
								else { $description = $titulo.'. '.$description;}
							}
							$pasamos = 1;
						}
						
						if($_REQUEST['view']=='category'&&$_REQUEST['id'])
						{
							$query = "SELECT description FROM #__categories WHERE id=".(int)$_REQUEST['id'];
							$db->setQuery($query);
							$row = $db->loadObject();
							if($row->description) { $description = strip_tags($row->description);}
							else { $description = $titulo.'. '.$description;}
							$pasamos = 1;
						}
						
						if($_REQUEST['view']=='section'&&$_REQUEST['id'])
						{
							$query = "SELECT description FROM #__sections WHERE id=".(int)$_REQUEST['id'];
							$db->setQuery($query);
							$row = $db->loadObject();
							if($row->description) { $description = strip_tags($row->description);}
							else { $description = $titulo.'. '.$description;}
							$pasamos = 1;
						}		
					}
					
					if($pasamos == 0) {	$description = $titulo.'. '.$description;	}			
				}
				
			$document->setDescription($description);
		}
				
		# // Remove auto generated mootool from header  
		$headerstuff = $document->getHeadData(); 
		$scripts = $headerstuff['scripts'];
		
		if($scripts){
		foreach($scripts as $t=>$v)
		{
			if($t=='/media/system/js/mootools.js'&&$this->params->get('hidemootols')) { unset($headerstuff['scripts'][$t]); }
			if($t=='/media/system/js/caption.js'&&$this->params->get('hidecaption')) { unset($headerstuff['scripts'][$t]); }
			}
		}
			
	
		/*
		
		$metaTags = $headerstuff['metaTags'];
		
		foreach($metaTags as $t=>$v)
		{
			echo($t.'-');
			if($t=='generator'&&$this->params->get('hidemootols')) { unset($headerstuff['metatags'][$t]); }
			}
		*/
		
		
		$document->setHeadData($headerstuff); 
 	
		return true;
	}
	
	
	function cut_string($string, $charlimit)
		{
			if(substr($string,$charlimit-1,1) != ' ')
			{
				$string = substr($string,'0',$charlimit);
				$array = explode(' ',$string);
				array_pop($array);
				$new_string = implode(' ',$array);
				return $new_string.' ...';
				}
			else
				{
				return substr($string,'0',$charlimit-1).' ...';
			}
		}
}